import scriptcontext as _sc
from scriptcontext import doc as _doc
import math
import random
from array import array
import Rhino
import rhinoscriptsyntax as rs
import Dashboard as dash
import Util
from Rhino.Geometry import Vector3d
from Rhino.Geometry import Point3d
import System
from System import Guid
from System.Drawing import Color
rs.UnlockObjects(rs.AllObjects())
rs.DeleteObjects(rs.AllObjects())


class _Node():
    def __init__(self, parent, position, isTip, settings = dash.knobs):
        self.parent = parent
        self.position = position
        self.isTip = isTip
        self.settings = settings
        self.influencedBy = []
        self.fresh = True

    def draw(self):
        cir = []
        if self.settings['ShowNodes']:
            cir = rs.AddCircle(self.position, 0.5)
            meshS = rs.AddPlanarMesh(cir)
            rs.DeleteObject(cir)
            rs.ObjectColor(meshS, Color.Green)
            rs.LockObject(meshS)
        return (cir)

    def getNextNode(self, averageAttractorDirection) :
        self.isTip = False
        length = self.settings['nDia']
        endVec = rs.VectorScale(averageAttractorDirection, length)
        self.nextPosition = rs.VectorCreate(self.position, endVec)
        newNode = _Node(self, self.nextPosition, True)
        return newNode
""""
print dash.knobs
parent = 'None'
pt1 = rs.AddPoint(0,0,0)
pt2 = rs.AddPoint(0,1,0)
dirVec = rs.VectorCreate(pt1, pt2)
parentNode = _Node(None, pt1, True)
parentNode.draw()
childNode = parentNode.getNextNode(dirVec)
childNode.draw()
secChildNode = childNode.getNextNode(dirVec)
secChildNode.draw()
"""