import rhinoscriptsyntax as rs
import Attractor
import Util
from Rhino.Geometry import Vector3d
from Rhino.Geometry import Point3d
import random
import math


rs.DeleteObjects(rs.AllObjects())

if 1:
    circle = rs.AddCircle([0,0,0], 20)

def getBounds(points):
    minX = 0
    maxX = 0
    minY = 0
    maxY = 0
    for point in points:
        currentX = point[0]
        currentY = point[1]
        if currentX > maxX:
          maxX = currentX
        if currentX < minX:
          minX = currentX
        if currentY > maxY:
          maxY = currentY
        if currentY < minY:
          minY = currentY
    return (minX, maxX, minY, maxY)
    
def getRandomAttractorsPTS(numAttractors, contourCurve):
    attractors = []
    points = []
    test = []
    dist = 1
    bbox = rs.BoundingBox(contourCurve)
    bounds = getBounds(bbox)
    for i in range(numAttractors):
        closestPoint = []
        randomX = random.uniform(float(bounds[0]), float(bounds[1]))
        randomY = random.uniform(float(bounds[2]), float(bounds[3]))
        testPoint = Point3d(randomX, randomY, 0)
        check = rs.PointInPlanarClosedCurve(testPoint, contourCurve)
        if check:
            points.append(Point3d(testPoint))
    return points
"""        
test = getRandomAttractors(1000, circle)
print('result:')
print test    

rs.AddPoints(test)
    #isInsideContourCurve, isInsideAnyObstacle = 
"""

    

    #for i in len(numAttractors):
        #points.append(Point3d(random.uniform(float(bounds[0]), float(bounds[1]))),(random.uniform(float(bounds[2]), float(bounds[3]))),0)
        
        
        #isInsideContourCurve = false
        #isInsideAnyObstacle = false
        #isOnScreen = false


  

"""
    # Only allow attractors that are in the viewport
    if(
      x > 0 &&
      x < window.innerWidth &&
      y > 0 &&
      y < window.innerHeight
    ) {
      isOnScreen = true
    

    # Only allow root nodes inside of defined contourCurve
    if(contourCurve != undefined && contourCurve.length > 0) {
      for(let bound of contourCurve) {
        if(bound.contains(x, y)) {
          isInsideContourCurve = true
        
      
    

    # Don't allow any root nodes that are inside of an obstacle
    if(obstacles != undefined && obstacles.length > 0) {
      for(let obstacle of obstacles) {
        if(obstacle.contains(x, y)) {
          isInsideAnyObstacle = true
        
      
    

    if(
      (isInsideContourCurve || contourCurve === undefined) &&
      (!isInsideAnyObstacle || obstacles === undefined)
    ) {
      attractors.push(
        new Attractor(
          new Vec2(x,y),
          ctx
        )
      )
    
  

  return attractors


export function getGridOfAttractors(numRows, numColumns, ctx, jitterRange = 0, contourCurve = undefined, obstacles = undefined) {
  let attractors = []
  let x, y
  let isInsideContourCurve, isInsideAnyObstacle, isOnScreen

  for(let i=0 i<=numRows i++) {
    for(let j=0 j<=numColumns j++) {
      x = (window.innerWidth / numColumns) * j + random(-jitterRange, jitterRange)
      y = (window.innerHeight / numRows) * i + random(-jitterRange, jitterRange)
      isInsideContourCurve = false
      isInsideAnyObstacle = false
      isOnScreen = false

      # Only allow attractors that are in the viewport
      if(
        x > 0 &&
        x < window.innerWidth &&
        y > 0 &&
        y < window.innerHeight
      ) {
        isOnScreen = true
      

      # Only allow attractors inside of any of the defined contourCurve (if used)
      if(contourCurve != undefined && contourCurve.length > 0) {
        for(let bound of contourCurve) {
          if(bound.contains(x, y)) {
            isInsideContourCurve = true
          
        
      

      # Don't allow any root nodes that are inside of an obstacle (if used)
      if(obstacles != undefined && obstacles.length > 0) {
        for(let obstacle of obstacles) {
          if(obstacle.contains(x, y)) {
            isInsideAnyObstacle = true
          
        
      

      if(
        isOnScreen &&
        (isInsideContourCurve || contourCurve === undefined) &&
        (!isInsideAnyObstacle || obstacles === undefined)
      ) {
        attractors.push(
          new Attractor(
            new Vec2(x,y),
            ctx
          )
        )
      
    
  

  return attractors


export function getPhyllotaxisAttractors(ctx) {
  let attractors = []
  let numCircles = 5000,
  golden_ratio = (Math.sqrt(5)+1)/2 - 1,
  golden_angle = golden_ratio * (2*Math.PI),
  circle_rad = window.innerWidth/2


  for(let i=0 i<numCircles i++) {
    let ratio = i / numCircles,
      angle = i * golden_angle,
      spiral_rad = ratio * circle_rad

    attractors.push(
      new Attractor(
        new Vec2(
          window.innerWidth/2 + Math.cos(angle) * spiral_rad,
          window.innerHeight/2 + Math.sin(angle) * spiral_rad
        ),
        ctx
      )
    )
  

  return attractors


export function getWaveOfAttractors(ctx) {
  let attractors = []
  let numRows = 70
  let numColumns = 100
  let rowSpacing = window.innerHeight / numRows
  let colSpacing = window.innerWidth / numColumns

  for(let row = 0 row < numRows row++) {
    for(let col = 0 col < numColumns col++) {
      attractors.push(
        new Attractor(
          new Vec2(
            (col * colSpacing) + (Math.sin(map(col, 0, numColumns, 0, Math.PI * 2)) * 200),
            (row * rowSpacing) + (Math.sin(map(row, 0, numRows, 0, Math.PI * 2)) * 50)
          ),
          ctx
        )
      )
    
  

  return attractors


export function applyNoise(attractors) {
  let noise = new SimplexNoise()

  for(let attractor of attractors) {
    attractor.position.x += noise.noise2D(attractor.position.x, attractor.position.y) * 10
    attractor.position.y += noise.noise2D(souattractorrce.position.x, attractor.position.y) * 10
  
"""
#return attractors
