import scriptcontext as _sc
from scriptcontext import doc as _doc
import math
import random
from array import array
import Rhino
import rhinoscriptsyntax as rs
import Dashboard as DB
import Util
from Rhino.Geometry import Vector3d
from Rhino.Geometry import Point3d
import System
from System import Guid
from System.Drawing import Color

def getBounds(points):
    minX = 0
    maxX = 0
    minY = 0
    maxY = 0
    for point in points:
        currentX = point[0]
        currentY = point[1]
        if currentX > maxX:
          maxX = currentX
        if currentX < minX:
          minX = currentX
        if currentY > maxY:
          maxY = currentY
        if currentY < minY:
          minY = currentY
    return (minX, maxX, minY, maxY)
    
def getRandomAttractors(numAttractors, contourCurve):
    attractors = []
    points = []
    test = []
    dist = 1
    bbox = rs.BoundingBox(contourCurve)
    bounds = getBounds(bbox)
    for i in range(numAttractors):
        closestPoint = []
        randomX = random.uniform(float(bounds[0]), float(bounds[1]))
        randomY = random.uniform(float(bounds[2]), float(bounds[3]))
        testPoint = Point3d(randomX, randomY, 0)
        check = rs.PointInPlanarClosedCurve(testPoint, contourCurve)
        if check:
            points.append(Point3d(testPoint))
    return points