import scriptcontext as _sc
from scriptcontext import doc as _doc
import math
import random
from array import array
import Rhino
import rhinoscriptsyntax as rs
import Dashboard as dash
import Util
from Rhino.Geometry import Vector3d
from Rhino.Geometry import Point3d
import System
from System import Guid
from System.Drawing import Color
import Dashboard as dash
rs.UnlockObjects(rs.AllObjects())
rs.DeleteObjects(rs.AllObjects())
import kdtree as kdtree

# This class emulates a tuple, but contains a useful payload
class Item(object):
    def __init__(self, x, y, data):
        self.coords = (x, y)
        self.data = data

    def __len__(self):
        return len(self.coords)

    def __getitem__(self, i):
        return self.coords[i]

    def __repr__(self):
        return 'Item({}, {}, {})'.format(self.coords[0], self.coords[1], self.data)

# Now we can add Items to the tree, which look like tuples to it
point1 = Item(2, 3, 'First')
point2 = Item(3, 4, 'Second')
point3 = Item(5, 2, ['some', 'list'])

# Again, from a list of points
tree = kdtree.create([point1, point2, point3])

#  The root node
print(tree)

# ...contains "data" field with an Item, which contains the payload in "data" field
print(tree.data.data)

# All functions work as intended, a payload is never lost
print(tree.search_nn([1, 2]))